; AutoIt Version: 3.3
; Language:       English
; Platform:       Win9x/NT
; Author:       kargas


#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#Include <Misc.au3>

If _Singleton("KMTOR", 0)=0 Then
	Exit
EndIf

$winruntor=(@scriptdir & "\KMTOR.exe" & " -silent")
$ostype=StringInStr (@OSType, "NT")


$polipobin=(@scriptdir & "\App\polipo.exe")
$torbin=(@scriptdir & "\App\tor.exe")
$polipoconfig=(@scriptdir & "\Data\Polipo\polipo.conf")
$poliposet=StringReplace ($polipoconfig, "\", "/")
$polipopexe=($polipobin & " -c " & """" & $poliposet & """")
;msgbox(0, $polipopexe, $polipopexe)

$torwelcome=(@scriptdir & "\DOCS\welcome.htm")
$kmpath=(stringtrimright(@scriptdir,9) & "\k-meleon.exe")
$kmwelcome=($kmpath & " " & $torwelcome)

if fileexists($polipobin)=0 or fileexists($polipoconfig)=0 or fileexists($polipoconfig)=0 then
msgbox(48, "KMTOR Error", "Missing or corrupted files, please reinstall KM TOR.  ", 8)
exit
endif

if $cmdline[0]<>1 then
exit
else
processparms()
endif

func processparms()
if $cmdline[1]=("-firstrun") then
torfirstrun()
elseif $cmdline[1]=("-start") then
torstartNT()
else 
if $cmdline[1]=("-kill") then
torkill()
elseif $cmdline[1]=("-quit") then
torquit()
else
if $cmdline[1]=("-torwinon") then
torwinon()
elseif $cmdline[1]=("-torwinoff") then
torwinoff()
else
if $cmdline[1]=("-silent") then
torwinrunner()
endif
endif
endif
endif
endfunc

func torstartNT()
if processexists("tor.exe")=0 and processexists("polipo.exe")=0 then
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
winwait("[CLASS:KMeleon Browser Window]", "")
$kmwin=WinGetPos("[CLASS:KMeleon Browser Window]", "")
$extra=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59396 )
$tab=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 1080 )
$status=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59393 )
$tinypp = GUICreate("TOR STATS", 170, 28,$kmwin[0]+6, $kmwin[1]+$extra[3]+$tab[3]+3, BitOR( $WS_POPUP, $WS_EX_TOPMOST))
$label = GUICtrlCreateLabel("TOR : initialising...", 7, 6, 150, 20)
GUISetBkColor(0x88A64A)
GUISetState(@SW_SHOW)
While 1
WinActivate ("[CLASS:KMeleon Browser Window]", "")
$msg = GUIGetMsg()
WinSetOnTop("TOR STATS", "", 1)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
sleep(2444)
GUICtrlSetData( $label, "TOR : establishing connections")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 40%")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 80%")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 100%")
sleep(2444)
GUISetBkColor(0x7489C0)
GUICtrlSetData( $label, "TOR : Proxy Network ready")
sleep(2444)
GUIDelete()
ExitLoop
WEnd
elseif processexists("tor.exe")=0 and processexists("polipo.exe") then
run($torbin, "", @SW_HIDE)
else
if processexists("tor.exe") and processexists("polipo.exe")=0 then
while processexists("tor.exe")
processclose("tor.exe")
sleep(44)
wend
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
elseif processexists("tor.exe") and processexists("polipo.exe") then
winwait("[CLASS:KMeleon Browser Window]", "")
$kmwin=WinGetPos("[CLASS:KMeleon Browser Window]", "")
$extra=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59396 )
$tab=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 1080 )
$status=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59393 )
$tinypp = GUICreate("TOR STATS", 170, 28,$kmwin[0]+6, $kmwin[1]+$extra[3]+$tab[3]+3, BitOR( $WS_POPUP, $WS_EX_TOPMOST))
$label = GUICtrlCreateLabel("TOR : Network is active...", 7, 6, 150, 20)
GUISetBkColor(0x7489C0)
GUISetState(@SW_SHOW)
While 1
WinActivate ("[CLASS:KMeleon Browser Window]", "")
$msg = GUIGetMsg()
WinSetOnTop("TOR STATS", "", 1)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
sleep(6444)
GUIDelete()
ExitLoop
WEnd
endif
endif
exit
endfunc

func torstart9x()
$defcmd=RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Policies\WinOldApp", "Disabled")
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Policies\WinOldApp", "Disabled", 0)
if processexists("tor.exe")=0 and processexists("polipo.exe")=0 then
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
winwait("[CLASS:KMeleon Browser Window]", "")
$kmwin=WinGetPos("[CLASS:KMeleon Browser Window]", "")
$extra=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59396 )
$tab=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 1080 )
$status=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59393 )
$tinypp = GUICreate("TOR STATS", 170, 28,$kmwin[0]+6, $kmwin[1]+$extra[3]+$tab[3]+3, BitOR( $WS_POPUP, $WS_EX_TOPMOST))
$label = GUICtrlCreateLabel("TOR : initialising...", 7, 6, 150, 20)
GUISetBkColor(0x88A64A)
GUISetState(@SW_SHOW)
While 1
WinActivate ("[CLASS:KMeleon Browser Window]", "")
$msg = GUIGetMsg()
WinSetOnTop("TOR STATS", "", 1)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
sleep(2444)
GUICtrlSetData( $label, "TOR : establishing connections")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 40%")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 80%")
sleep(2444)
GUICtrlSetData( $label, "TOR : bootstrapped 100%")
sleep(2444)
GUISetBkColor(0x7489C0)
GUICtrlSetData( $label, "TOR : Proxy Network ready")
sleep(2444)
GUIDelete()
ExitLoop
WEnd
elseif processexists("tor.exe")=0 and processexists("polipo.exe") then
run($torbin, "", @SW_HIDE)
else
if processexists("tor.exe") and processexists("polipo.exe")=0 then
while processexists("tor.exe")
processclose("tor.exe")
sleep(44)
wend
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
elseif processexists("tor.exe") and processexists("polipo.exe") then
winwait("[CLASS:KMeleon Browser Window]", "")
$kmwin=WinGetPos("[CLASS:KMeleon Browser Window]", "")
$extra=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59396 )
$tab=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 1080 )
$status=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59393 )
$tinypp = GUICreate("TOR STATS", 214, 28,$kmwin[0]+6, $kmwin[1]+$extra[3]+$tab[3]+3, BitOR( $WS_POPUP, $WS_EX_TOPMOST))
$label = GUICtrlCreateLabel("TOR is active.. ", 7, 6, 150, 20)
GUISetBkColor(0x7489C0)
GUISetState(@SW_SHOW)
While 1
WinActivate ("[CLASS:KMeleon Browser Window]", "")
$msg = GUIGetMsg()
WinSetOnTop("TOR STATS", "", 1)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
sleep(6444)
GUIDelete()
ExitLoop
WEnd
endif
endif
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Policies\WinOldApp", "Disabled", $defcmd)
exit
endfunc

func torkill()
$kmwin=WinGetPos("[CLASS:KMeleon Browser Window]", "")
$extra=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59396 )
$tab=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 1080 )
$status=ControlGetPos ("[CLASS:KMeleon Browser Window]", "", 59393 )
$tinypp = GUICreate("TOR STATS", 170, 28,$kmwin[0]+6, $kmwin[1]+$extra[3]+$tab[3]+3, BitOR( $WS_POPUP, $WS_EX_TOPMOST))
$label = GUICtrlCreateLabel("TOR is shuttingdown.. ", 7, 6, 150, 20)
GUISetBkColor(0xAF1222)
GUISetState(@SW_SHOW)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
$msg = GUIGetMsg()
WinSetOnTop("TOR STATS", "", 1)
WinActivate ("[CLASS:KMeleon Browser Window]", "")
while processexists("tor.exe") or processexists("polipo.exe")
processclose("tor.exe")
processclose("polipo.exe")
sleep(44)
wend
sleep(6444)
GUIDelete()
exit
endfunc

func torquit()
if processexists("restartkm.exe") then
exit
else 
while processexists("tor.exe") or processexists("polipo.exe")
processclose("tor.exe")
processclose("polipo.exe")
sleep(44)
wend
exit
endif
endfunc

func torwinon()
;msgbox(0,"fuckon","fuckon")
RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "TOR-Network", "REG_SZ", $winruntor)
exit
endfunc

func torwinoff()
;msgbox(0,"fuckoff","fuckoff")
RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "TOR-Network")
exit
endfunc

func torwinrunner()
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
exit
endfunc

func torfirstrun()
run($polipopexe, "", @SW_HIDE)
run($torbin, "", @SW_HIDE)
processwaitclose("k-meleon.exe")
run($kmwelcome)
exit
endfunc